#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <fcntl.h>
#include <unistd.h>
#include <time.h>
#include <termios.h>
#include <sys/time.h>
#include <sys/types.h>
#include <sys/ioctl.h>
#include <pthread.h>

#include "func_extern.h"
#include "mg3.h"
#include "uss.h"

#define D_DEG 5 
#define D_TIME 50

int correction(void){
	int uss1,uss2,uss12;
	int maxdif;
	int e_count = 0;
	int errer = 0;
	int par[4];

	par[1]=D_TIME;

	printf("correction function start\n");

	maxdif=0;

	while(1){
		while(1){
			usleep(150000);
			//uss data 取得
			uss1=uss_get(1);
			usleep(150*1000);
			uss2=uss_get(2);
			usleep(150*1000);
			uss12=(uss1+uss2)/2;
			printf("uss1 = %d\nuss2 = %d\n",uss1,uss2);

			//uss errer
			if(uss1 > USS_MAX && uss2 > USS_MAX){
				printf("USS ERROR!\n");
				e_count++;
				if(e_count == 10){
					printf("post does not exist.\n");
					errer = -1;
					//break;
					return(errer);
				}else{
					printf("uss errer_count = %d\n",e_count);
					continue;
				}
			}
			//片方が物体に反射していない場合
			else if(uss1 > USS_MAX){
				e_count = 0;
				par[0]=D_DEG;
				//右に数度回転
				motor('r',par); 
				break;
			}
			else if(uss2 > USS_MAX){
				e_count = 0;
				par[0]=-D_DEG;
				//左に数度回転
				motor('r',par); 
				break;
			}

			//正対出来ている
			else if(abs(uss1-uss2-USS12_DIFF)<=maxdif){
				errer = 1; 
				return errer;
			}
			if(uss1-USS12_DIFF > uss2) {
				e_count = 0;
				par[0]=D_DEG;
				//右に数度回転
				motor('r',par); 
				break;
			} 
			if(uss2+USS12_DIFF > uss1) {
				e_count = 0;
				par[0]=-D_DEG;
				//左に数度回転
				motor('r',par);  
				break;
			}
		}
	}

	return errer;
}
