/*
	Open device files and initialize variables
*/

#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <fcntl.h>
#include <unistd.h>
#include <time.h>
#include <termios.h>
#include <sys/time.h>
#include <sys/types.h>
#include <sys/ioctl.h>
#include <pthread.h>

#include "func_extern.h"
#include "control.h"
#include "irs_ts_ws.h"
#include "motor.h"
#include "uss.h"

#define SERIAL_PORT "/dev/ttyS0"

//extern char irs[4], ts[4], ws[4];
//extern int uss[4];
//extern pthread_t irs_ts_ws_task;
//extern pthread_t uss_task;
//extern pthread_attr_t attr_irs_ts_ws;
//extern pthread_attr_t attr_uss;
//extern struct sched_param sched_param;
//extern int fd1, fd2;
//extern pthread_attr_t attr_motor;

int initialize(void){

	int i;

        printf("Initialization\n");

	//デバイスファイルを開く
/*USSのスレッドで初期化
        if ((fd0 = open(FNAME1, O_RDWD)) < 0) {
                fprintf(stderr, "Error opening %s\n",SERIAL_PORT);
                exit(1);
        }
*/
/*
        if ((fd1 = open(M_PORT_L, O_RDWR)) < 0) {
                fprintf(stderr, "Error opening %s\n",M_PORT_L);
                exit(1);
        }
        if ((fd2 = open(M_PORT_R, O_RDWR)) < 0) {
                fprintf(stderr, "Error opening %s\n",M_PORT_R);
                exit(1);
        }
*/
/*IRS_TS_WSのスレッドで初期化
        if ((fd3 = open("/dev/irs_ts_ws", O_RDONLY)) < 0) {
                fprintf(stderr, "Error opening /dev/irs_ts\n");
                exit(1);
        }
*/
/*
        if ((fd4 = open("/dev/irs_code", O_RDWR)) < 0) {
        	fprintf(stderr, "Error opening /dev/irs_code\n");
       		exit(1);
        }
*/
/*
        if ((ctl = open("/dev/rtf1", O_WRONLY)) < 0) {
                fprintf(stderr, "Error opening /dev/rtf1\n");
                exit(1);
        }
*/
/*	fd1=open(M_PORT_L, O_RDWR);
	if(fd1 < 0){
		perror(M_PORT_L);
		exit(-1);
	}
	fd2=open(M_PORT_R, O_RDWR);
	if(fd2 < 0){
		perror(M_PORT_R);
		exit(-1);
	}
*/
        //スレッドの設定

        pthread_attr_init (&attr_irs_ts_ws);
        sched_param.sched_priority = 20;
        pthread_attr_setschedpolicy(&attr_irs_ts_ws, SCHED_RR);
        pthread_attr_setschedparam (&attr_irs_ts_ws, &sched_param);

        pthread_attr_init (&attr_motor);
        sched_param.sched_priority = 19;
        pthread_attr_setschedpolicy(&attr_motor, SCHED_RR);
        pthread_attr_setschedparam (&attr_motor, &sched_param);

/*
        pthread_attr_init (&attr_encoder);
        sched_param.sched_priority = 20;
        pthread_attr_setschedpolicy(&attr_encoder, SCHED_RR);
        pthread_attr_setschedparam (&attr_encoder, &sched_param);
*/

        pthread_attr_init (&attr_uss);
        sched_param.sched_priority = 18;
        pthread_attr_setschedpolicy(&attr_uss, SCHED_RR);
        pthread_attr_setschedparam (&attr_uss, &sched_param);


	//スレッドの生成

        pthread_create(&irs_ts_ws_task, &attr_irs_ts_ws, irs_ts_ws, (void *)1);
//      pthread_create(&encoder_task, &attr_encoder, &encoder, (void *)1);
//        pthread_create(&uss_task, &attr_uss, &uss_read, (void *)1);
        //pthread_create(&uss_task2, &attr_uss, &uss_read2, (void *)1);

	for(i=0;i<4;i++){
		irs[i] = '0';
		ts[i] = '0';
		ws[i] = '0';
		uss[i] = 0;
	}
/*	
	ml.fd = open(M_PORT_L, O_RDWR);
	if ( ml.fd < 0 ) {
		perror("Open");
		return -1;
	}
	mr.fd = open(M_PORT_R, O_RDWR);
	if ( mr.fd < 0 ) {
		perror("Open");
		return -1;
	}
*/	
	printf("finish\n");
	return 0;
}

