/*
ボールが見つかるまで45°ずつ回転
見つかったら直進し、(TSが反応したら終了)適度に進んで終了
	(使用機能) RE, (TS), IMG(BALL)
*/

#include <stdio.h>
#include <stdlib.h>
#include <pthread.h>
#include <highgui.h>
#include "func_extern.h"
#include "control.h"
#include "show_window.h"

#define MAX_DIS	5000
#define DEG_ERR	30

int main(void){
	int ret, i, n=0, v_l=20, v_r=20;
	double	dis_ave=0,deg_ave=0;
	int mparm[4];

	//初期化
	ret = initialize();
	printf("initialize.\n");

//画像環境整備
#ifdef __USE_CV_WINDOW__
	cvNamedWindow(inputIMG, CV_WINDOW_AUTOSIZE);
	cvNamedWindow(windowNamecolThreshold, CV_WINDOW_AUTOSIZE);
	cvNamedWindow(windowNameHoughCircle, CV_WINDOW_AUTOSIZE);
#endif	

	ball.dis = -999; ball.deg = -999;

//開始
	printf("program start.\n");

	while(1){
		//5回ボール認識をして、平均値を取る
		dis_ave = deg_ave = 0;
		n=0;
		for(i=0;i<5;i++){
			ball_detect();
			usleep(1*1000*1000);
			printf("detect.\ndis = %d, deg = %d\n",(int)ball.dis,(int)ball.deg);
			if(ball.dis != -999 && ball.deg != -999){
				dis_ave = dis_ave + ball.dis;
				deg_ave = deg_ave + ball.deg;
				n++;
			}
		}
		if(dis_ave != 0) dis_ave = dis_ave/n;
		if(deg_ave != 0) deg_ave = deg_ave/n;

		//ボールを発見できていなかった場合、45度回転し、ボール認識へ戻る
		if(dis_ave == 0 && deg_ave == 0){
			printf("dis_ave = %d, deg_ave = %d",(int)dis_ave,(int)deg_ave);
			printf("not find ball.\n");
			mparm[0]=-45; mparm[1]=315;
			//motor('r',-45,315);
			motor('r',mparm);
		//発見できた場合、whileを抜ける
		}else{
			printf("find ball.\ndis_ave = %d, deg_ave = %d\n;",(int)dis_ave,(int)deg_ave);
			break;
		}
	}

	//ボールに正対
	printf("rotate : deg = %d\n",(int)deg_ave);
	mparm[0]=(int)(deg_ave),mparm[1]=(int)abs(deg_ave)*7;
	//motor('r',(int)(deg_ave),(int)abs(deg_ave)*7);
	motor('r',mparm);

	usleep(500*1000);

	//ボールに直進
	mparm[0]=(int)dis_ave+150;mparm[1]=(int)(dis_ave+150)*3;
	//motor('s',(int)dis_ave+150,(int)(dis_ave+150)*3);
	motor('s',mparm);

	printf("ball get.\n");

//終了
	close(fd1);
	close(fd2);

#ifdef __USE_CV_WINDOW__	
	cvDestroyWindow(inputIMG);
	cvDestroyWindow(windowNamecolThreshold);
	cvDestroyWindow(windowNameHoughCircle);
#endif

	return(0);
}
