/*
	Thread functions
	irs_ts_ws:  
		Read data of IRS, TS, and WS.
	encoder:
		Read counts of rotary encoder.
	uss_read:
		Read distance data mesuared by USS.
*/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>
#include <fcntl.h>
#include <unistd.h>
#include <time.h>
#include <termios.h>
#include <sys/time.h>
#include <sys/types.h>
#include <sys/ioctl.h>
#include <pthread.h>
#include "func_extern.h"
//#include "control.h"
#include "irs_ts_ws.h"
#include "uss.h"
extern int fd3;
extern int irs_flag,ts_flag,ws_flag;
extern char irs[4],ts[4],ws[4];
void *irs_ts_ws(void* t)
{
        char data_a[13];
        int i;
        int r_val;

        while(1){

		irs_flag=0,ts_flag=0,ws_flag=0;

        	if ((fd3 = open("/dev/irs_ts_ws", O_RDONLY)) < 0) {
               		fprintf(stderr, "Error opening /dev/irs_ts_ws\n");
                	exit(0);
        	}

               // data_a=(char*)irs;
                r_val=read(fd3,data_a,13);

                for(i=0;i<4;i++){
                        ts[i]=data_a[i];
                        if(data_a[i]=='1') ts_flag=1;
                        //data_a++;
                }

                for(i=0;i<4;i++){
                        irs[i]=data_a[i+4];
                        if(data_a[i+4]=='1' && i >=2) irs_flag=1;
                        //data_a++;
                }

                for(i=0;i<4;i++){
                        ws[i]=data_a[i+8];
                        if(data_a[i+8]=='1') ws_flag=1;
                        //data_a++;
		}


		close(fd3);
		usleep(50000);
        }
        pthread_exit(0);
}

extern int uss[4];
void *uss_read(void *arg){
	int uss_no = (int)arg;
	int data;
	
	while(1){
		pthread_testcancel();
		data = uss_get(uss_no);
		usleep(500*1000);
		if(data == -1){
			printf("uss_read: uss_no error\n");
			pthread_exit((void*)-1);
		}
		uss[uss_no - 1] = data;
//		printf("uss[%d] = %d\n", uss_no, uss[uss_no - 1]);
	}
	
	pthread_exit(0);
}
