#include <stdint.h>
#include <stdlib.h>
#include <pthread.h>
#include "control.h"

int motor_send_control_packet (int fd, uint8_t speed, uint8_t kp, uint8_t ki);
int motor_recv_status_packet (int fd, int8_t *speed, uint16_t *pwm, int32_t *round);

int put_motor(MotorInfo *ml, MotorInfo *mr)
{
	//int err;
	int t_l=0, t_r=0;
	int speed_l_tmp, speed_r_tmp;
	char speed_l=0, speed_r=0;
	//ゼロ割禁止
	if(ml->t*mr->t == 0){
		if(ml->t == 0) t_l = 1;
		else t_r = 1;
	}else{
		t_l = ml->t;
		t_r = mr->t;
	}
	printf("dis=%d,t=%d\n",ml->send_dis,t_l);
	speed_l_tmp = (int)((MOTOR_CYCLE/t_par)*(ml->send_dis/t_l));
	speed_r_tmp = (int)((MOTOR_CYCLE/t_par)*(mr->send_dis/t_r));
	printf("tmp=%d\n",speed_l_tmp);
	//速度を制限
	if(abs(speed_l_tmp) > VMAX){
		if(speed_l_tmp < 0) speed_l = VMAX;
		else 				speed_l = -VMAX;
	}else{
		speed_l = (char)speed_l_tmp;
	}
	if(abs(speed_r_tmp) > VMAX){
		if(speed_r_tmp < 0) speed_r = VMAX;
		else 				speed_r = -VMAX;
	}else{
		speed_r = (char)speed_r_tmp;
	}
	ml->speed = speed_l;
	mr->speed = speed_r;
	//送信
	printf("ml.fd=[%d],speed_l=[%d],ml.kp=[%d],ml.ki=[%d]\n",ml->fd,speed_l, ml->kp, ml->ki);
	motor_send_control_packet (ml->fd, speed_l, ml->kp, ml->ki);
	motor_send_control_packet (mr->fd, speed_r, mr->kp, mr->ki);
	return 0;
}

int get_motor(MotorInfo *ml, MotorInfo *mr)
{
	//int err;
	char speed_l=0, speed_r=0;
	
	//受信
	motor_recv_status_packet(ml->fd, &speed_l, &(ml->pwm), &(ml->puls));
	motor_recv_status_packet(mr->fd, &speed_r, &(mr->pwm), &(mr->puls));
	
	//計算
	ml->speed = (t_par/MOTOR_CYCLE)*speed_l;
	mr->speed = (t_par/MOTOR_CYCLE)*speed_r;
	ml->recv_dis = t_par*ml->puls;
	mr->recv_dis = t_par*mr->puls;
	
	return 0;
}
